]> git.madduck.net Git - code/vcsh.git/commitdiff

madduck's git repository

Every one of the projects in this repository is available at the canonical URL git://git.madduck.net/madduck/pub/<projectpath> — see each project's metadata for the exact URL.

All patches and comments are welcome. Please squash your changes to logical commits before using git-format-patch and git-send-email to patches@git.madduck.net. If you'd read over the Git project's submission guidelines and adhered to them, I'd be especially grateful.

SSH access, as well as push access can be individually arranged.

If you use my repositories frequently, consider adding the following snippet to ~/.gitconfig and using the third clone URL listed for each project:

[url "git://git.madduck.net/madduck/"]
  insteadOf = madduck:

Use exit and {} instead of return and ()
authorRichard Hartmann <richih.mailinglist@gmail.com>
Thu, 24 Nov 2011 19:05:30 +0000 (20:05 +0100)
committerRichard Hartmann <richih.mailinglist@gmail.com>
Thu, 24 Nov 2011 19:05:30 +0000 (20:05 +0100)
doc/error_codes.md
vcsh

index 06d760d3d540e10b9b65580f3ec41867bd12458f..e6636442c8ef069c4ea4515c486674ec2a957026 100644 (file)
@@ -1,3 +1,17 @@
 * 0: OK
 * 1: Generic error
 * 0: OK
 * 1: Generic error
-* 10: source-only command was called without vcsh being sourced
+* 10: Init failed because $GIT_DIR exists
+* 11: Could not enter $GIT_WORK_TREE
+* 12: No repository found
+* 13: Required directory exists but is not a directory
+* 14: Could not create directory
+* 15: Could not create file
+* 16: Potentially harmful operation aborted
+* 17: Files that would be overwritten exist; fix manually
+
+* 50: Could not create directory
+* 51: Could not create file
+* 52: Could not move directory
+* 53: Could not move file
+
+* 99: Error code reserved for actions that should never happen
diff --git a/vcsh b/vcsh
index a38e55f695a78b7cd0f36fa2bfc2c470755961d4..8ba0f2709ee62fd3e0a982bc80af0886e88fea6b 100755 (executable)
--- a/vcsh
+++ b/vcsh
@@ -47,12 +47,11 @@ init() {
        verbose "init() begin"
        [ -e "$GIT_DIR" ] &&
                echo "$SELF: fatal: $GIT_DIR exists" &&
        verbose "init() begin"
        [ -e "$GIT_DIR" ] &&
                echo "$SELF: fatal: $GIT_DIR exists" &&
-               return 21
+               return 10
        export GIT_WORK_TREE="$HOME"
        mkdir -p "$GIT_WORK_TREE"
        cd "$GIT_WORK_TREE" ||
        export GIT_WORK_TREE="$HOME"
        mkdir -p "$GIT_WORK_TREE"
        cd "$GIT_WORK_TREE" ||
-               (echo "$SELF: fatal: could not enter $GIT_WORK_TREE" &&
-                return 1) || return $?
+               { echo "$SELF: fatal: could not enter $GIT_WORK_TREE"; return 11; }
        cd "$GIT_WORK_TREE"
        git init
        setup
        cd "$GIT_WORK_TREE"
        git init
        setup
@@ -63,7 +62,7 @@ use() {
        verbose "use() begin"
        if [ ! -d "$GIT_DIR" ]; then
                echo E: no repository found for "$VCSH_REPO_NAME" >&2
        verbose "use() begin"
        if [ ! -d "$GIT_DIR" ]; then
                echo E: no repository found for "$VCSH_REPO_NAME" >&2
-               return 1
+               return 12
        fi
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
        fi
        export GIT_DIR
        export GIT_WORK_TREE="$(git config --get core.worktree)"
@@ -86,24 +85,24 @@ elif [ "$1" = 'delete' ] ||
      [ "$1" = 'run' ] ||
      [ "$1" = 'seed-gitignore' ] ||
      [ "$1" = 'setup' ]; then
      [ "$1" = 'run' ] ||
      [ "$1" = 'seed-gitignore' ] ||
      [ "$1" = 'setup' ]; then
-       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && return 1
+       [ -z $2 ] && echo "$SELF $1: error: please specify repository to work on" && exit 1
        export VCSH_COMMAND="$1"
        export VCSH_REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
        shift 2
        export VCSH_EXTERNAL_COMMAND="$*"
        if [ "$VCSH_COMMAND" = 'run' ]; then
        export VCSH_COMMAND="$1"
        export VCSH_REPO_NAME="$2"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
        shift 2
        export VCSH_EXTERNAL_COMMAND="$*"
        if [ "$VCSH_COMMAND" = 'run' ]; then
-               [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && return 1
+               [ -z "$VCSH_EXTERNAL_COMMAND" ] && echo "$SELF $1 $2: error: please specify a command" && exit 1
        fi
 elif [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
        export VCSH_COMMAND="$1"
 else
        fi
 elif [ "$1" = 'help' ] ||
      [ "$1" = 'list' ]; then
        export VCSH_COMMAND="$1"
 else
-       [ -z $1 ] && help && return 0
+       [ -z $1 ] && help && exit 0
        export VCSH_COMMAND='run'
        export VCSH_REPO_NAME="$1"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
        export VCSH_COMMAND='run'
        export VCSH_REPO_NAME="$1"
        export GIT_DIR="$VCSH_BASE/$VCSH_REPO_NAME.git"
-       [ -d $GIT_DIR ] || (help && return 1) || return 0
+       [ -d $GIT_DIR ] || { help; exit 1; }
        shift 1
        export VCSH_EXTERNAL_COMMAND="git $*"
 fi
        shift 1
        export VCSH_EXTERNAL_COMMAND="git $*"
 fi
@@ -113,11 +112,11 @@ for check_directory in "$VCSH_BASE" "$HOME/.gitignore.d"
 do
        if [ ! -d "$check_directory" ]; then
                if [ -e "$check_directory" ]; then
 do
        if [ ! -d "$check_directory" ]; then
                if [ -e "$check_directory" ]; then
-                       echo "$SELF: error: $check_directory exists but is not a directory" >&2
-                       return 2
+                       echo "$SELF: fatal: $check_directory exists but is not a directory" >&2
+                       exit 13
                else
                        echo "$SELF: info: attempting to create $check_directory"
                else
                        echo "$SELF: info: attempting to create $check_directory"
-                       mkdir -p "$check_directory" || (echo "$SELF: error: could not create $check_directory" >&2; return 2) || return $?
+                       mkdir -p "$check_directory" || { echo "$SELF: fatal: could not create $check_directory" >&2; exit 50; }
                fi
        fi
 done
                fi
        fi
 done
@@ -138,7 +137,7 @@ if [ "$VCSH_COMMAND" = 'clone' ]; then
        [ "$VCSH_CONFLICT" = '1' ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
        [ "$VCSH_CONFLICT" = '1' ] &&
                echo "$SELF: fatal: will stop after fetching and not try to merge!\n" &&
                echo "  Once this situation has been resolved, run 'vcsh run <foo> git pull' to finish cloning.\n" &&
-               return 3
+               exit 17
        git merge origin/master
        verbose "clone end"
 
        git merge origin/master
        verbose "clone end"
 
@@ -150,7 +149,7 @@ elif [ "$VCSH_COMMAND" = 'delete' ]; then
        verbose "delete begin"
        old_dir="$PWD"
        cd "$HOME"
        verbose "delete begin"
        old_dir="$PWD"
        cd "$HOME"
-       use || return $?
+       use || exit $?
        echo "$SELF: info: This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
        echo "$SELF: info: This operation WILL DETROY DATA!"
        files=$(git ls-files)
        echo "These files will be deleted:
@@ -160,7 +159,7 @@ $files
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
        read answer
 AGAIN, THIS WILL DELETE YOUR DATA!
 To continue, type \"Yes, do as I say\""
        read answer
-       [ "x$answer" = "xYes, do as I say" ] || return 1
+       [ "x$answer" = "xYes, do as I say" ] || exit 16
        for file in $files; do
                rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
        done
        for file in $files; do
                rm -f $file || echo "$SELF: info: could not delete '$file', continuing with deletion"
        done
@@ -170,7 +169,7 @@ To continue, type \"Yes, do as I say\""
 
 elif [ "$VCSH_COMMAND" = 'enter' ]; then
        verbose "enter begin"
 
 elif [ "$VCSH_COMMAND" = 'enter' ]; then
        verbose "enter begin"
-       use || return $?
+       use || exit $?
        $SHELL
        verbose "enter end"
 
        $SHELL
        verbose "enter end"
 
@@ -188,13 +187,13 @@ elif [ "$VCSH_COMMAND" = 'list' ]; then
 
 elif [ "$VCSH_COMMAND" = 'run' ]; then
        verbose "run begin"
 
 elif [ "$VCSH_COMMAND" = 'run' ]; then
        verbose "run begin"
-       use || return $?
+       use || exit $?
        $VCSH_EXTERNAL_COMMAND
        verbose "run end"
 
 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        verbose "seed-gitignore begin"
        $VCSH_EXTERNAL_COMMAND
        verbose "run end"
 
 elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        verbose "seed-gitignore begin"
-       use || return $?
+       use || exit $?
        # Switching directory as this has to be executed from $HOME to be of any use.
        # Going back into old directory at the end in case `vcsh use` is reactivated.
        old_dir="$PWD"
        # Switching directory as this has to be executed from $HOME to be of any use.
        # Going back into old directory at the end in case `vcsh use` is reactivated.
        old_dir="$PWD"
@@ -207,7 +206,7 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
                done;
        done | sort -u)
        tempfile=$(mktemp) ||
                done;
        done | sort -u)
        tempfile=$(mktemp) ||
-               (echo "$SELF: fatal: could not create tempfile" && return 1) || return $?
+               { echo "$SELF: fatal: could not create tempfile"; exit 51; }
        echo '*' > "$tempfile"
        for gitignore in $gitignores; do
                echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
        echo '*' > "$tempfile"
        for gitignore in $gitignores; do
                echo "$gitignore" | sed 's/^/!/' >> "$tempfile"
@@ -215,28 +214,27 @@ elif [ "$VCSH_COMMAND" = 'seed-gitignore' ]; then
        done
        diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
                rm -f "$tempfile" &&
        done
        diff -N "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" > /dev/null &&
                rm -f "$tempfile" &&
-               return
+               exit
        if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
                echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
                mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
        if [ -e "$HOME/.gitignore.d/$VCSH_REPO_NAME" ]; then
                echo "$SELF: info: $HOME/.gitignore.d/$VCSH_REPO_NAME differs from new data, moving it to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"
                mv -f "$HOME/.gitignore.d/$VCSH_REPO_NAME" "$HOME/.gitignore.d/$VCSH_REPO_NAME.bak" ||
-                       (echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak" &&
-                        return 1) || return $?
+                       { echo "$SELF: fatal: could not move $HOME/.gitignore.d/$VCSH_REPO_NAME to $HOME/.gitignore.d/$VCSH_REPO_NAME.bak"; exit 53; }
        fi
        mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
        fi
        mv -f "$tempfile" "$HOME/.gitignore.d/$VCSH_REPO_NAME" ||
-               (echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && return 1) || return $?
+               { echo "$SELF: fatal: could not move $tempfile to $HOME/.gitignore.d/$VCSH_REPO_NAME" && exit 53; }
        cd "$old_dir"
        verbose "seed-gitignore end"
 
 elif [ "$VCSH_COMMAND" = 'setup' ]; then
        verbose "seed-gitignore begin"
        cd "$old_dir"
        verbose "seed-gitignore end"
 
 elif [ "$VCSH_COMMAND" = 'setup' ]; then
        verbose "seed-gitignore begin"
-       use   || return $?
-       setup || return $?
+       use   || exit $?
+       setup || exit $?
        verbose "seed-gitignore end"
 
 else
        verbose "defaulting to calling help()"
        help
        echo "$SELF: fatal: You should never reach this code. File a bug, please."
        verbose "seed-gitignore end"
 
 else
        verbose "defaulting to calling help()"
        help
        echo "$SELF: fatal: You should never reach this code. File a bug, please."
-       return 99
+       exit 99
 
 fi
 
 fi